<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 27.210 Load all orders - Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <h2 class="text-center">Danh sách đơn hàng</h2>
                <table class="table text-center table-striped" id="table-order">
                    <thead>
                        <tr>
                            <th scope="col">Order Code</th>
                            <th scope="col">Kích cỡ combo</th>
                            <th scope="col">Loại pizza</th>
                            <th scope="col">Nước uống</th>
                            <th scope="col">Thành tiền</th>
                            <th scope="col">Họ và tên</th>
                            <th scope="col">Số điện thoại</th>
                            <th scope="col">Trạng thái</th>
                            <th scope="col">Chi tiết</th>
                        </tr>
                    </thead>
                    <tbody>

                    </tbody>
                </table>
            </div>
        </div>
    </div>

    <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gEND_ROW_TABLE = -1;
    const gCOLUMN_CODE_ORDER = 0;
    const gCOLUMN_COMBO_SIZE = 1;
    const gCOLUMN_PIZZA = 2;
    const gCOLUMN_DRINK = 3;
    const gCOLUMN_AMOUNT = 4;
    const gCOLUMN_FULL_NAME = 5;
    const gCOLUMN_PHONE = 6;
    const gCOLUMN_STATUS = 7;
    const gCOLUMN_DETAIL = 8;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    
    function onPageLoading() {
        
        getAllOrders();
       
    }

    // load data of all orders to the table
    function loadOrderToTable(paramXMLHttpAllOrder) {
                    
        //reach to "tbody" of the table element
        var vTableElement = document.getElementById("table-order");
        var vTableBody = vTableElement.getElementsByTagName("tbody")[0];
        
        for (var i=0; i<paramXMLHttpAllOrder.length; i++){
            //create a new row in the tbody
            var vNewRow = vTableBody.insertRow(gEND_ROW_TABLE);
            //creat new cells in the row
            var vCodeOrderCell = vNewRow.insertCell(gCOLUMN_CODE_ORDER);
            var vComboCell = vNewRow.insertCell(gCOLUMN_COMBO_SIZE);
            var vPizzaCell = vNewRow.insertCell(gCOLUMN_PIZZA);
            var vDrinkCell = vNewRow.insertCell(gCOLUMN_DRINK);
            var vAmountCell = vNewRow.insertCell(gCOLUMN_AMOUNT);
            var vFullNameCell = vNewRow.insertCell(gCOLUMN_FULL_NAME);
            var vPhoneCell = vNewRow.insertCell(gCOLUMN_PHONE);
            var vStatusCell = vNewRow.insertCell(gCOLUMN_STATUS);
            var vDetailCell = vNewRow.insertCell(gCOLUMN_DETAIL);

            vCodeOrderCell.innerHTML = paramXMLHttpAllOrder[i].orderCode;
            vComboCell.innerHTML = paramXMLHttpAllOrder[i].kichCo;
            vPizzaCell.innerHTML = paramXMLHttpAllOrder[i].loaiPizza;
            vDrinkCell.innerHTML = paramXMLHttpAllOrder[i].idLoaiNuocUong;
            vAmountCell.innerHTML = paramXMLHttpAllOrder[i].thanhTien;
            vFullNameCell.innerHTML = paramXMLHttpAllOrder[i].hoTen;
            vPhoneCell.innerHTML = paramXMLHttpAllOrder[i].soDienThoai;
            vStatusCell.innerHTML = paramXMLHttpAllOrder[i].trangThai;

            //create detail button
            var vDetailButton = document.createElement("button");
            //append the button to the detail element
            vDetailCell.appendChild(vDetailButton);
            vDetailButton.innerHTML = "Chi tiết";
            vDetailButton.className = "btn btn-success";
            //add click event to the button
            vDetailButton.addEventListener("click", function(){
                onDetailButtonClick(this)});
            //creat datasets of the button
            var vCellIndex = paramXMLHttpAllOrder[i];
            vDetailButton.setAttribute("data-codeorder", paramXMLHttpAllOrder[i].orderCode);
            vDetailButton.setAttribute("data-id", vCellIndex.id);
            }
        }


    //function click of the detail button
    function onDetailButtonClick(paramOrder){
       console.log(paramOrder)
        //get value of the dataset
        var vOrderCode = paramOrder.dataset.codeorder;
        var vId = paramOrder.dataset.id;
                            
        //display in console.log
        console.log("%cDETAIL BY CODE ORDER: ", "color:orange");
        console.log("Order Code: " + vOrderCode);
        console.log("Id: " + vId);

        //add query string
        const vUSER_DETAIL = "file:///C:/Users/hphat/Desktop/J2232/2023-02-14%20-%20Copy/orderDetail%20-%20for%20employee%20usage.html";
        var vUrlSideToOpen = vUSER_DETAIL + "?" + 
        "id=" + vId + 
        "&orderCode=" + vOrderCode;
        window.location.href = vUrlSideToOpen; 
    
    }


    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    
    // function to load all orders from the server
    function getAllOrders() {
            
        var vXmlHttpGetAllOrders = new XMLHttpRequest();
        callApiToGetAllOrders(vXmlHttpGetAllOrders);
        vXmlHttpGetAllOrders.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                //console.log("%cRESPONSE-TEXT: ","color:orange",this.responseText)
                var vResponseParsing = JSON.parse(this.responseText);
                //console.log("%cRESPONSE-TEXT: ","color:orange",vResponseParsing)
                loadOrderToTable(vResponseParsing);
            }
        }
    }

    // call API for all orders
    function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
        const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
        paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
        paramXMLHttpGetAllOrders.send();
    }

    
    
    

    </script>
</body>

</html>